<?php
/*
Plugin Name: Flat PM
Plugin URI: http://wp-pro.online
Description: Плагин для вывода рекламны и интерактивного контента. Увеличиваем конверсию, поведенческие факторы и выхлоп с сайтов! <a href="https://t.me/joinchat/UUXPMRJR9zRJUjzx">Канал в телеграм</a>
Version: 2.649
Author: Михаил Flat
Author URI: https://mehanoid.pro/
*/

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


define( 'FLATPM_SLUG', dirname( plugin_basename( __FILE__ ) ) );
define( 'FLATPM_VERSION', '?2.649' );
define( 'FLATPM_INT_MAX', PHP_INT_MAX - 100 );
define( 'FLATPM_URL', plugin_dir_url( __FILE__ ) );
define( 'FLATPM_DIR', __DIR__ );
define( 'FLATPM_PATH', 'path' );
define( 'FLATPM_UPPD', FLATPM_DIR . '/' . FLATPM_PATH . '/updater' );
define( 'FLATPM_FUNC', FLATPM_DIR . '/' . FLATPM_PATH . '/functions' );
define( 'FLATPM_NEWS', FLATPM_DIR . '/' . FLATPM_PATH . '/form_news/news.php' );

if( !function_exists( 'flat_pm_recurseCopy' ) ){
	function flat_pm_recurseCopy( $src, $dst, $childFolder = '' ) {

		$dir = opendir( $src );
		mkdir( $dst );

		if ( $childFolder != '' ) {
			mkdir( $dst . '/' . $childFolder );

			while( false !== ( $file = readdir( $dir ) ) ) {
				if ( ( $file != '.' ) && ( $file != '..' ) ) {
					if ( is_dir($src . '/' . $file) ) {
						flat_pm_recurseCopy( $src . '/' . $file, $dst . '/' . $childFolder . '/' . $file );
					} else {
						copy( $src . '/' . $file, $dst .'/'. $childFolder . '/' . $file );
					}
				}
			}
		}else{
			while( false !== ( $file = readdir( $dir ) ) ) {
				if ( ( $file != '.' ) && ( $file != '..' ) ) {
					if ( is_dir( $src . '/' . $file ) ) {
						flat_pm_recurseCopy( $src . '/' . $file, $dst . '/' . $file );
					} else {
						copy( $src . '/' . $file, $dst . '/' . $file );
					}
				}
			}
		}

		closedir( $dir );
	}
}

if( !function_exists( 'flat_pm_del_dir' ) ){
	function flat_pm_del_dir( $src ){
		$dir = opendir( $src );

		while( ( $entry = readdir( $dir ) ) !== false ){
			if ( $entry != "." && $entry != ".." ){
				if ( is_dir( $src . "/" . $entry ) ){
					flat_pm_del_dir( $src . "/" . $entry );
				} else {
					unlink( $src . "/" . $entry );
				}
			}
		}

		closedir( $dir );
		rmdir( $src );
	}
}


if( FLATPM_SLUG == 'flat-pm' || FLATPM_SLUG == 'flat_pm' ){

	function action_deactivate_plugins(){

		$new_dir = str_replace( FLATPM_SLUG, 'flatpm-wp', FLATPM_DIR );

		flat_pm_recurseCopy( FLATPM_DIR, $new_dir );

		if( !function_exists( 'deactivate_plugins' ) )
			require_once ABSPATH .'/wp-admin/includes/plugin.php';

		deactivate_plugins( FLATPM_SLUG . '/flat_pm.php' );

		$current   = get_option( 'active_plugins', array() );
		$current[] = 'flatpm-wp/flat_pm.php';
		sort( $current );
		update_option( 'active_plugins', $current );

		flat_pm_del_dir( FLATPM_DIR );

	}
	add_action( 'admin_init', 'action_deactivate_plugins' );

}


include_once FLATPM_FUNC . '/flat-core.php';
include_once FLATPM_FUNC . '/flat-ajax_admin.php';
include_once FLATPM_FUNC . '/flat-ajax_front.php';
include_once FLATPM_FUNC . '/flat-shortcode.php';
include_once FLATPM_FUNC . '/flat-scripts.php';
include_once FLATPM_FUNC . '/flat-header_footer.php';
include_once FLATPM_FUNC . '/flat-filter_content.php';


if( FLATPM_SLUG != 'flatpm-wp' ){
	include_once FLATPM_UPPD . '/plugin-update-checker.php';

	$FlatPMUpdateChecker = PucFactory::buildUpdateChecker( 'https://mehanoid.pro/updates/?action=get_metadata&slug=' . FLATPM_SLUG, __FILE__, FLATPM_SLUG );
}


class FlatPM_Obj{
	function __construct(){
		add_action( 'admin_enqueue_scripts', function( $suffix ){
			$accept_array = array(
				'toplevel_page_blocks_form',
				'flat-pm_page_add_blocks_form',
				'flat-pm_page_header_footer',
				'flat-pm_page_sliders_form',
				'flat-pm_page_video_form',
				'flat-pm_page_block_ip_form',
				'flat-pm_page_settings_form',
				'flat-pm_page_export_import',
				'flat-pm_page_license_form',
			);
			if( in_array( $suffix, $accept_array ) ) {
				wp_enqueue_style( 'flat_pm', FLATPM_URL . 'assets/back/style.css', array(), FLATPM_VERSION, 'all' );
				wp_enqueue_style( 'flat_pm_codemirror', FLATPM_URL . 'assets/back/codemirror.css', array(), FLATPM_VERSION, 'all' );
				wp_enqueue_style( 'flat_pm_Fira-Code', 'https://fonts.googleapis.com/css2?family=Fira+Code:wght@500&display=swap', array(), FLATPM_VERSION, 'all' );
				wp_enqueue_style( 'editor-buttons' );

				wp_enqueue_script( 'flat_pm', FLATPM_URL . 'assets/back/js.js', array( 'jquery', 'wp-color-picker' ), FLATPM_VERSION, false );

				$args = array(
					'type' => 'text/html',
					'codemirror' => array(
						'theme' => 'material'
					)
				);

				$settings = wp_enqueue_code_editor( $args );

				if ( false === $settings ) {
					return;
				}

				wp_add_inline_script(
					'code-editor',
					sprintf( '
						jQuery( function($){
							$(\'textarea[id^="sub_block_"],textarea[id^="flat_settings_"],textarea[id^="flat_pm_check_video_"]\').each( function(){
								var textArea = this,
									editor = wp.codeEditor.initialize( textArea, %s );

								editor.codemirror.on( \'change\', function(){
									editor.codemirror.save();
									$( textArea ).trigger( \'flatpm_change\' );
								} );

								$(textArea).on( \'change\', function(){
									editor.codemirror.setValue(this.value);
									$( textArea ).trigger( \'flatpm_change\' );
								} );
							} );
						} );', wp_json_encode( $settings ) )
				);
			}
		} );

		add_action( 'admin_menu', array( &$this, 'flat_admin' ) );

		add_action( 'admin_head', 'flat_pm_admin_head' );
		function flat_pm_admin_head(){
			echo '<script>localStorage.setItem( "visit_f_bool", "false" );</script>';
		}
	}


	function blocks_form(){
		flat_pm_init();
		include_once FLATPM_PATH . '/form.php';
	}
	function add_blocks_form(){
		flat_pm_init();
		include_once FLATPM_PATH . '/form_blocks/add.php';
	}
	function video_form(){
		flat_pm_init();
		include_once FLATPM_PATH . '/form_settings/video.php';
	}
	function header_footer(){
		flat_pm_init();
		include_once FLATPM_PATH . '/form_settings/header_footer.php';
	}
	function block_ip_form(){
		flat_pm_init();
		include_once FLATPM_PATH . '/form_settings/block_ip.php';
	}
	function settings_form(){
		flat_pm_init();
		include_once FLATPM_PATH . '/form_settings/settings.php';
	}
	function export_import(){
		flat_pm_init();
		include_once FLATPM_PATH . '/form_settings/export_import.php';
	}
	function license_form(){
		flat_pm_init();
		include_once FLATPM_PATH . '/form_settings/license.php';
	}


	function flat_admin(){
		register_setting( 'flat_plugin_field', 'flat_plugin_options_me' );

		$option_list = array(
			'flat_plugin_options_me'       => '',
			'flat_plugin_settings_me'      => array(),
			'flat_plugin_header_footer_me' => array(),
			'flat_plugin_video_me'         => array(),
			'flat_pm_cross_color'          => '#ffffff',
			'flat_pm_cross_background'     => '#000000',
			'flat_pm_cross_text_color'     => '#ffffff',
			'flat_pm_cross_offset'         => 'false',
			'flat_pm_cross_width'          => '34',
			'flat_pm_cross_height'         => '34',
			'flat_pm_cross_weight'         => '3',
		);

		foreach ( $option_list as $key => $default ) {
			get_option( $key ) == false && update_option( $key, $default );
		} unset( $default, $key );

		$menu_icon = include_once 'assets/img/flat_pm.svg.php';

		$settings = get_option( 'flat_plugin_settings_me' );
		$cap = ( !isset($settings['editor_manage'] ) || $settings['editor_manage'] != 'true' ) ? 'manage_options' : 'read_private_posts';

		add_menu_page( 'Основные настройки', 'Flat PM', $cap, 'blocks_form', '', $menu_icon );

		$submenu_list = array(
			'blocks_form'     => 'Ваши блоки',
			'add_blocks_form' => 'Добавить блок',
			'header_footer'   => 'Header и footer',
			'video_form'      => 'Видео прероллы',
			'block_ip_form'   => 'Блокировка ip',
			'settings_form'   => 'Опции плагина',
			'export_import'   => 'Экспорт/импорт',
			'license_form'    => 'Лицензия',
		);

		foreach ( $submenu_list as $key => $value ) {
			add_submenu_page( 'blocks_form', $value, $value, $cap, $key, array( &$this, $key ) );
		} unset( $value, $key );
	}
}

$FlatPM_Obj = new FlatPM_Obj();
?>