<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


if( !function_exists( 'flat_pm_clear_all_cache' ) ){
	function flat_pm_clear_all_cache(){
		$settings = get_option( 'flat_plugin_settings_me' );

		if( isset($settings['clear_cache'] ) && $settings['clear_cache'] == 'true' ){

			if( class_exists( 'd_cache' ) ){
				d_cache::clear_all();
			}

			if( class_exists( 'HyperCache' ) ){
				HyperCache::clean();
			}

			if( function_exists( 'w3tc_flush_all' ) ){
				w3tc_flush_all();
			}

			if( function_exists( 'wp_cache_clean_cache' ) ){
				global $file_prefix;
				wp_cache_clean_cache( $file_prefix );
			}

			if( class_exists( 'WpFastestCache' ) ){
				WpFastestCache::deleteCache();
				WpFastestCache::deleteCache(true);
			}

			if( class_exists( 'rocket_clean_domain' ) ){
				rocket_clean_domain();
			}

			if( class_exists( 'autoptimizeCache' ) ){
				autoptimizeCache::clearall();
			}

			if( class_exists( 'Breeze_Admin' ) ){
				Breeze_Admin::breeze_clear_all_cache();
			}

		}
	}
}


if( !function_exists( 'flat_pm_AB_func' ) ){
	function flat_pm_AB_func( $html ){
		$group_bool = false;

		foreach ($html as $value) {
			if( $value['group'] != '0' ) $group_bool = true;
		} unset( $value );

		$output = ( $group_bool == false ) ? 'Нет' : 'Да';

		return $output;
	}
}


if( !function_exists( 'flat_pm_block_update' ) ){
	function flat_pm_block_update( $method, $arr ){
		$flat_pm_html      = $arr['html'];
		$flat_pm_view      = $arr['view'];
		$flat_pm_date      = $arr['date'];
		$flat_pm_geo       = $arr['geo'];
		$flat_pm_referer   = $arr['referer'];
		$flat_pm_browser   = $arr['browser'];
		$flat_pm_cookies   = $arr['cookies'];
		$flat_pm_utmget    = $arr['utmget'];
		$flat_pm_ip        = $arr['ip'];
		$flat_pm_os        = $arr['os'];
		$flat_pm_role      = $arr['role'];
		$flat_pm_count_sub = count( $arr['html'] );
		$flat_pm_AB        = flat_pm_AB_func( $arr['html'] );
		$block_enabled     = ( $arr['view']['view_enabled'] == 'true' ) ? 1 : 0;

		$args = array(
			'ID'          => (int)$arr['ID'],
			'post_title'  => $arr['name_of_block'],
			'post_status' => 'publish',
			'post_type'   => 'flat_pm_block'
		);
		$upd_post_id = wp_update_post( $args );

		foreach ( $flat_pm_html as $key => $value ) {

			if( !isset($value['resolution_from']) || $value['resolution_from'] == '' )
				$flat_pm_html[$key]['resolution_from'] = '∞';

			if( !isset($value['resolution_to']) || $value['resolution_to'] == '' )
				$flat_pm_html[$key]['resolution_to'] = '∞';

		} unset( $value, $key );

		if( !flat_do_some() ){
			foreach ( $flat_pm_html as $key => $value ) {
				$flat_pm_html[$key]['group']           = '0';
				$flat_pm_html[$key]['resolution_from'] = '∞';
				$flat_pm_html[$key]['resolution_to']   = '∞';
			}
			unset( $value, $key );

			$flat_pm_geo['geo_enabled']            = 'false';
			$flat_pm_geo['city_enabled']           = array('');
			$flat_pm_geo['city_disabled']          = array('');
			$flat_pm_geo['country_enabled']        = array('');
			$flat_pm_geo['country_disabled']       = array('');

			$flat_pm_referer['enabled']            = 'false';
			$flat_pm_referer['referer_enabled']    = array('');
			$flat_pm_referer['referer_disabled']   = array('');

			$flat_pm_browser['enabled']            = 'false';
			$flat_pm_browser['browser_enabled']    = array('');
			$flat_pm_browser['browser_disabled']   = array('');

			$flat_pm_os['enabled']                 = 'false';
			$flat_pm_os['os_enabled']              = array('');
			$flat_pm_os['os_disabled']             = array('');

			$flat_pm_cookies['enabled']            = 'false';
			$flat_pm_cookies['cookies_enabled']    = array('');
			$flat_pm_cookies['cookies_disabled']   = array('');

			$flat_pm_utmget['enabled']             = 'false';
			$flat_pm_utmget['utmget_enabled']      = array('');
			$flat_pm_utmget['utmget_disabled']     = array('');

			$flat_pm_ip['enabled']                 = 'false';

			$flat_pm_view['where']['show_in_cat']  = '0';
			$flat_pm_view['where']['show_in_home'] = '0';
			unset(
				$flat_pm_view['where']['posts_enabled'],
				$flat_pm_view['where']['posts_disabled'],
				$flat_pm_view['where']['tax_enabled'],
				$flat_pm_view['where']['tax_disabled']
			);

			$flat_pm_date['date_time_enabled']     = 'false';
			$flat_pm_date['time_from']             = '';
			$flat_pm_date['time_to']               = '';
			$flat_pm_date['date_date_enabled']     = 'false';
			$flat_pm_date['date_from']             = '13.3.2018';
			$flat_pm_date['date_to']               = '13.3.2018';

			$flat_pm_role['enabled']               = 'false';
			unset(
				$flat_pm_role['role_enabled'],
				$flat_pm_role['role_disabled']
			);
		}

		update_post_meta( (int)$arr['ID'], 'flat_pm_block_enabled', (int)$block_enabled );
		update_post_meta( (int)$arr['ID'], 'flat_pm_html',               $flat_pm_html );
		update_post_meta( (int)$arr['ID'], 'flat_pm_view',               $flat_pm_view );
		update_post_meta( (int)$arr['ID'], 'flat_pm_date',               $flat_pm_date );
		update_post_meta( (int)$arr['ID'], 'flat_pm_geo',                $flat_pm_geo );
		update_post_meta( (int)$arr['ID'], 'flat_pm_role',               $flat_pm_role );
		update_post_meta( (int)$arr['ID'], 'flat_pm_os',                 $flat_pm_os );
		update_post_meta( (int)$arr['ID'], 'flat_pm_cookies',            $flat_pm_cookies );
		update_post_meta( (int)$arr['ID'], 'flat_pm_utmget',             $flat_pm_utmget );
		update_post_meta( (int)$arr['ID'], 'flat_pm_ip',                 $flat_pm_ip );
		update_post_meta( (int)$arr['ID'], 'flat_pm_referer',            $flat_pm_referer );
		update_post_meta( (int)$arr['ID'], 'flat_pm_browser',            $flat_pm_browser );
		update_post_meta( (int)$arr['ID'], 'flat_pm_count_sub',          $flat_pm_count_sub );
		update_post_meta( (int)$arr['ID'], 'flat_pm_AB',                 $flat_pm_AB );

		flat_pm_clear_all_cache();

		die( json_encode( array( 'method' => $method, 'data' => array( 'ID' => $arr['ID'] ) ) ) );
	}
}


if( !function_exists( 'flat_pm_block_create' ) ){
	function flat_pm_block_create( $method, $arr ){
		$flat_pm_html      = $arr['html'];
		$flat_pm_view      = $arr['view'];
		$flat_pm_date      = $arr['date'];
		$flat_pm_geo       = $arr['geo'];
		$flat_pm_referer   = $arr['referer'];
		$flat_pm_browser   = $arr['browser'];
		$flat_pm_os        = $arr['os'];
		$flat_pm_cookies   = $arr['cookies'];
		$flat_pm_utmget    = $arr['utmget'];
		$flat_pm_ip        = $arr['ip'];
		$flat_pm_role      = $arr['role'];
		$flat_pm_count_sub = count( $arr['html'] );
		$flat_pm_AB        = flat_pm_AB_func( $arr['html'] );
		$block_enabled     = ( $arr['view']['view_enabled'] == 'true' ) ? 1 : 0;
		$block_cat_ID      = $arr['cat_ID'];

		$args = array(
			'post_title'  => $arr['name_of_block'],
			'post_status' => 'publish',
			'post_type'   => 'flat_pm_block'
		);
		$new_post_id = wp_insert_post( $args );

		foreach ( $flat_pm_html as $key => $value ) {

			if( !isset($value['resolution_from']) || $value['resolution_from'] == '' )
				$flat_pm_html[$key]['resolution_from'] = '∞';

			if( !isset($value['resolution_to']) || $value['resolution_to'] == '' )
				$flat_pm_html[$key]['resolution_to'] = '∞';

		} unset( $value, $key );

		if( !flat_do_some() ){
			foreach ( $flat_pm_html as $key => $value ) {
				$flat_pm_html[$key]['group']           = '0';
				$flat_pm_html[$key]['resolution_from'] = '∞';
				$flat_pm_html[$key]['resolution_to']   = '∞';
			}
			unset( $value, $key );

			$flat_pm_geo['geo_enabled']            = 'false';
			$flat_pm_geo['city_enabled']           = array('');
			$flat_pm_geo['city_disabled']          = array('');
			$flat_pm_geo['country_enabled']        = array('');
			$flat_pm_geo['country_disabled']       = array('');

			$flat_pm_referer['enabled']            = 'false';
			$flat_pm_referer['referer_enabled']    = array('');
			$flat_pm_referer['referer_disabled']   = array('');

			$flat_pm_browser['enabled']            = 'false';
			$flat_pm_browser['browser_enabled']    = array('');
			$flat_pm_browser['browser_disabled']   = array('');

			$flat_pm_os['enabled']                 = 'false';
			$flat_pm_os['os_enabled']              = array('');
			$flat_pm_os['os_disabled']             = array('');

			$flat_pm_cookies['enabled']            = 'false';
			$flat_pm_cookies['cookies_enabled']    = array('');
			$flat_pm_cookies['cookies_disabled']   = array('');

			$flat_pm_utmget['enabled']             = 'false';
			$flat_pm_utmget['utmget_enabled']      = array('');
			$flat_pm_utmget['utmget_disabled']     = array('');

			$flat_pm_ip['enabled']                 = 'false';

			$flat_pm_view['where']['show_in_cat']  = '0';
			$flat_pm_view['where']['show_in_home'] = '0';
			unset(
				$flat_pm_view['where']['posts_enabled'],
				$flat_pm_view['where']['posts_disabled'],
				$flat_pm_view['where']['tax_enabled'],
				$flat_pm_view['where']['tax_disabled']
			);

			$flat_pm_date['date_time_enabled']     = 'false';
			$flat_pm_date['time_from']             = '';
			$flat_pm_date['time_to']               = '';
			$flat_pm_date['date_date_enabled']     = 'false';
			$flat_pm_date['date_from']             = '13.3.2018';
			$flat_pm_date['date_to']               = '13.3.2018';

			$flat_pm_role['enabled']               = 'false';
			unset(
				$flat_pm_role['role_enabled'],
				$flat_pm_role['role_disabled']
			);
		}

		update_post_meta( (int)$new_post_id, 'flat_pm_order_ID',      (int)$new_post_id );
		update_post_meta( (int)$new_post_id, 'flat_pm_block_enabled', (int)$block_enabled );
		update_post_meta( (int)$new_post_id, 'flat_pm_html',               $flat_pm_html );
		update_post_meta( (int)$new_post_id, 'flat_pm_view',               $flat_pm_view );
		update_post_meta( (int)$new_post_id, 'flat_pm_date',               $flat_pm_date );
		update_post_meta( (int)$new_post_id, 'flat_pm_geo',                $flat_pm_geo );
		update_post_meta( (int)$new_post_id, 'flat_pm_role',               $flat_pm_role );
		update_post_meta( (int)$new_post_id, 'flat_pm_os',                 $flat_pm_os );
		update_post_meta( (int)$new_post_id, 'flat_pm_cookies',            $flat_pm_cookies );
		update_post_meta( (int)$new_post_id, 'flat_pm_utmget',             $flat_pm_utmget );
		update_post_meta( (int)$new_post_id, 'flat_pm_ip',                 $flat_pm_ip );
		update_post_meta( (int)$new_post_id, 'flat_pm_referer',            $flat_pm_referer );
		update_post_meta( (int)$new_post_id, 'flat_pm_browser',            $flat_pm_browser );
		update_post_meta( (int)$new_post_id, 'flat_pm_count_sub',          $flat_pm_count_sub );
		update_post_meta( (int)$new_post_id, 'flat_pm_AB',                 $flat_pm_AB );

		if( $block_cat_ID != '' ){
			wp_set_object_terms( $new_post_id, (int)$block_cat_ID, 'flat_pm_block_folders', false );
		}

		die( json_encode( array( 'method' => $method, 'data' => array( 'ID' => $new_post_id ) ) ) );
	}
}


if( !function_exists( 'flat_pm_block_activate' ) ){
	function flat_pm_block_activate( $method, $arr ){
		foreach ( $arr as $value ) {
			update_post_meta( (int)$value['block_ID'], 'flat_pm_block_enabled', (int)$value['enabled'] );

			$flat_pm_view = get_post_meta( (int)$value['block_ID'], 'flat_pm_view', true );
			$flat_pm_view['view_enabled'] = ( (int)$value['enabled'] == 1 ) ? 0 : 1;

			update_post_meta( (int)$value['block_ID'], 'flat_pm_view', $flat_pm_view );
		} unset( $value );

		flat_pm_clear_all_cache();

		die( json_encode( array( 'method' => $method, 'data' => '' ) ) );
	}
}


if( !function_exists( 'flat_pm_block_copy' ) ){
	function flat_pm_block_copy( $method, $arr ){
		global $wpdb;
		$post_id = $arr['block_ID'];
		$post    = get_post( $post_id );

		if ( !isset( $post ) || $post == null )
			die( json_encode( array( 'method' => $method, 'data' => 'Не удалось скопировать блок') ) );

		$args = array(
			'comment_status' => $post->comment_status,
			'ping_status'    => $post->ping_status,
			'post_content'   => $post->post_content,
			'post_excerpt'   => $post->post_excerpt,
			'post_name'      => $post->post_name,
			'post_parent'    => $post->post_parent,
			'post_password'  => $post->post_password,
			'post_status'    => $post->post_status,
			'post_title'     => $post->post_title.' (копия)',
			'post_type'      => $post->post_type,
			'to_ping'        => $post->to_ping,
			'menu_order'     => $post->menu_order
		);

		$new_post_id = wp_insert_post( $args );
		$taxonomies  = get_object_taxonomies($post->post_type);

		foreach ( $taxonomies as $taxonomy ) {
			$post_terms = wp_get_object_terms($post_id, $taxonomy, array('fields' => 'slugs'));
			wp_set_object_terms($new_post_id, $post_terms, $taxonomy, false);
		} unset( $taxonomy );

		$post_meta_infos = $wpdb->get_results("SELECT meta_key, meta_value FROM $wpdb->postmeta WHERE post_id=$post_id");
		if ( count($post_meta_infos) != 0 ) {
			$sql_query = "INSERT INTO $wpdb->postmeta (post_id, meta_key, meta_value) ";

			foreach ( $post_meta_infos as $meta_info ) {
				$meta_key = $meta_info->meta_key;

				if( $meta_key == '_wp_old_slug' )
					continue;

				$meta_value      = addslashes( $meta_info->meta_value );
				$sql_query_sel []= "SELECT $new_post_id, '$meta_key', '$meta_value'";
			}
			unset( $meta_info );

			$sql_query .= implode( " UNION ALL ", $sql_query_sel );
			$wpdb->query( $sql_query );
		}

		update_post_meta( (int)$new_post_id, 'flat_pm_order_ID', (int)$new_post_id );

		$taxonomy     = 'flat_pm_block_folders';
		$terms        = get_terms( $taxonomy, array('fields'=>'ids'));
		$args_flat_pm = array(
			'post_type' => 'flat_pm_block',
			'p'         => $new_post_id
		);

		$query = new WP_Query( $args_flat_pm );

		ob_start();

		if ( $query->have_posts() ) {
			while ( $query->have_posts() ) {
				$query->the_post();
				$block_id = get_the_ID();
		?>
		<div class="item_flat_block new_item_flat_block" data-block-id="<?php echo $block_id; ?>" style="overflow:hidden!important;opacity:0!important;max-height:0px!important;padding:0 20px!important">
			<div class="top_of_block">
				<input type="checkbox" name="check_block_id_<?php echo $block_id; ?>" id="check_block_id_<?php echo $block_id; ?>"><label for="check_block_id_<?php echo $block_id; ?>"></label>
				<a href="<?php echo get_site_url(); ?>/wp-admin/admin.php?page=blocks_form&block_id=<?php echo $block_id; ?>" class="name_of_block"><?php echo get_the_title(); ?></a>
				<div class="float_right">
					<a href="" class="to_top_block"></a>
					<a href="" class="to_bottom_block"></a>
				</div>
				<div class="float_right">
					<a href="" class="delete_this_block" title="Удалить блок"></a>
					<a href="" class="copy_this_block" title="Копировать блок"></a>
					<a href="" class="disable_this_block" title="Активировать?" data-enabled="<?php echo get_post_meta($block_id, 'flat_pm_block_enabled', true); ?>"></a>
				</div>
				<a class="more_of_this"></a>
			</div>
			<div class="bottom_of_block flat_clear">
				<div class="some_stat_block" style="margin:0">
				</div>
				<div class="some_stat_block">
				</div>
			</div>
		</div>
		<?php
			}
		}
		wp_reset_postdata();

		$output = ob_get_contents();
		ob_end_clean();

		flat_pm_clear_all_cache();

		die( json_encode( array( 'method' => $method, 'data' => array( 'html' => $output ) ) ) );
	}
}


if( !function_exists( 'flat_pm_block_delete' ) ){
	function flat_pm_block_delete( $method, $arr ){
		foreach ( $arr['block_id_arr'] as $value ) {
			wp_delete_post($value);
		} unset( $value );

		flat_pm_clear_all_cache();

		die( json_encode( array( 'method' => $method, 'data' => '' ) ) );
	}
}


if( !function_exists( 'flat_pm_block_move' ) ){
	function flat_pm_block_move( $method, $arr ){
		$first  = explode( '|', $arr[0] );
		$second = explode( '|', $arr[1] );

		update_post_meta( (int)$first[0], 'flat_pm_order_ID', (int)$first[1] );
		update_post_meta( (int)$second[0], 'flat_pm_order_ID', (int)$second[1] );

		flat_pm_clear_all_cache();

		die( json_encode( array( 'method' => $method, 'data' => '') ) );
	}
}


if( !function_exists( 'flat_pm_block_change_asc' ) ){
	function flat_pm_block_change_asc( $method, $arr ){
		$block_id = $arr['block_id'];
		$new_val = $arr['new_val'];

		update_post_meta( (int)$block_id, 'flat_pm_order_ID', (int)$new_val );

		flat_pm_clear_all_cache();

		die( json_encode( array( 'method' => $method, 'data' => '') ) );
	}
}


if( !function_exists( 'flat_pm_move_to_folder' ) ){
	function flat_pm_move_to_folder( $method, $arr ){
		$cat_id       = (int)$arr['cat_id'];
		$block_id_arr = $arr['block_id_arr'];

		$second_param = ( $cat_id != 0 ) ? array( $cat_id ) : NULL;

		foreach ( $block_id_arr as $block_id ) {
			wp_set_object_terms( $block_id, $second_param, 'flat_pm_block_folders', false );
		} unset( $block_id );

		flat_pm_clear_all_cache();

		die( json_encode( array( 'method' => $method, 'data' => '' ) ) );
	}
}


if( !function_exists( 'flat_pm_folder_add' ) ){
	function flat_pm_folder_add( $method, $arr ){
		wp_insert_term( $arr, 'flat_pm_block_folders' );

		die( json_encode( array( 'method' => $method, 'data' => '' ) ) );
	}
}


if( !function_exists( 'flat_pm_folder_remove' ) ){
	function flat_pm_folder_remove( $method, $arr ){
		wp_delete_term( $arr, 'flat_pm_block_folders', array( 'force_default' => true ) );

		flat_pm_clear_all_cache();

		die( json_encode( array( 'method' => $method, 'data' => '' ) ) );
	}
}


if( !function_exists( 'flat_pm_folder_rename' ) ){
	function flat_pm_folder_rename( $method, $arr ){
		wp_update_term( $arr['id'], 'flat_pm_block_folders', array( 'name' => $arr['name'] ) );

		die( json_encode( array( 'method' => $method, 'data' => '' ) ) );
	}
}


if( !function_exists( 'flat_pm_settings_update' ) ){
	function flat_pm_settings_update( $method, $arr ){
		$flat_plugin_settings_me = array(
			'once_post'            => $arr['once_post'],
			'adblock'              => $arr['adblock'],
			'editor_manage'        => $arr['editor_manage'],
			'deferred'             => $arr['deferred'],
			'deferred_events'      => $arr['deferred_events'],
			'untilscroll'          => $arr['untilscroll'],
			'untilscroll_selector' => $arr['untilscroll_selector'],
			'clear_cache'          => $arr['clear_cache'],
			'jquery_migrate'       => $arr['jquery_migrate'],
			'inseconds'            => $arr['inseconds'],
			'inseconds_mseconds'   => $arr['inseconds_mseconds'],
			'lighthouse'           => $arr['lighthouse'],
		);
		update_option( 'flat_plugin_settings_me', $flat_plugin_settings_me );

		update_option( 'flat_pm_cross_offset',     $arr['cross_offset'] );
		update_option( 'flat_pm_cross_background', $arr['cross_background'] );
		update_option( 'flat_pm_cross_color',      $arr['cross_color'] );
		update_option( 'flat_pm_cross_text_color', $arr['cross_text_color'] );
		update_option( 'flat_pm_cross_width',      $arr['cross_width'] );
		update_option( 'flat_pm_cross_height',     $arr['cross_height'] );
		update_option( 'flat_pm_cross_weight',     $arr['cross_weight'] );

		flat_pm_clear_all_cache();

		die( json_encode( array( 'method' => $method, 'data' => '' ) ) );
	}
}


if( !function_exists( 'flat_pm_settings_header_footer_update' ) ){
	function flat_pm_settings_header_footer_update( $method, $arr ){
		update_option( 'flat_plugin_header_footer_me', $arr );

		flat_pm_clear_all_cache();

		die( json_encode( array( 'method' => $method, 'data' => '' ) ) );
	}
}


if( !function_exists( 'flat_pm_settings_video_update' ) ){
	function flat_pm_settings_video_update( $method, $arr ){
		update_option( 'flat_plugin_video_me', $arr );

		flat_pm_clear_all_cache();

		die( json_encode( array( 'method' => $method, 'data' => '' ) ) );
	}
}


if( !function_exists( 'flat_pm_settings_ip_update' ) ){
	function flat_pm_settings_ip_update( $method, $arr ){
		$file = ABSPATH . '/ip.txt';

		file_put_contents( $file, $arr['ip'] );

		die( json_encode( array( 'method' => $method, 'data' => '' ) ) );
	}
}


if( !function_exists( 'flat_pm_folder_update' ) ){
	function flat_pm_folder_update( $method, $arr ){
		if( !flat_do_some() )
			die( json_encode( array( 'Вы хакер? :D' ) ) );

		$flat_pm_view    = $arr['view'];
		$flat_pm_date    = $arr['date'];
		$flat_pm_geo     = $arr['geo'];
		$flat_pm_referer = $arr['referer'];
		$flat_pm_browser = $arr['browser'];
		$flat_pm_cookies = $arr['cookies'];
		$flat_pm_utmget  = $arr['utmget'];
		$flat_pm_ip      = $arr['ip'];
		$flat_pm_os      = $arr['os'];
		$flat_pm_role    = $arr['role'];
		$folder_enabled  = ($arr['view']['view_enabled'] == 'true') ? 1 : 0;

		$upd_term_id = wp_update_term( (int)$arr['ID'], 'flat_pm_block_folders', array( 'name' => $arr['name_of_block'] ) );

		update_term_meta( (int)$arr['ID'], 'flat_pm_folder_enabled', (int)$folder_enabled );
		update_term_meta( (int)$arr['ID'], 'flat_pm_view',                $flat_pm_view );
		update_term_meta( (int)$arr['ID'], 'flat_pm_date',                $flat_pm_date );
		update_term_meta( (int)$arr['ID'], 'flat_pm_geo',                 $flat_pm_geo );
		update_term_meta( (int)$arr['ID'], 'flat_pm_role',                $flat_pm_role );
		update_term_meta( (int)$arr['ID'], 'flat_pm_cookies',             $flat_pm_cookies );
		update_term_meta( (int)$arr['ID'], 'flat_pm_utmget',              $flat_pm_utmget );
		update_term_meta( (int)$arr['ID'], 'flat_pm_ip',                  $flat_pm_ip );
		update_term_meta( (int)$arr['ID'], 'flat_pm_os',                  $flat_pm_os );
		update_term_meta( (int)$arr['ID'], 'flat_pm_referer',             $flat_pm_referer );
		update_term_meta( (int)$arr['ID'], 'flat_pm_browser',             $flat_pm_browser );

		flat_pm_clear_all_cache();

		die( json_encode( array( 'method' => $method, 'data' => array( 'ID' => $arr['ID'] ) ) ) );
	}
}


if( !function_exists( 'flat_pm_get_li_of_posts' ) ){
	function flat_pm_get_li_of_posts( $method, $arr ){
		$list       = $arr['list'];
		$post_types = $arr['post_types'];
		$exclude_id = (isset($arr['exclude_id']) && !empty($arr['exclude_id'])) ? $arr['exclude_id'] : array();

		$output = '';
		$flat_post = array();

		if(empty($post_types) || empty($list))
			die( json_encode( array( 'method' => $method, 'data' => array( 'html' => $output ) ) ) );

		foreach ( $list as $value ) {
			if( is_numeric($value) ){
				if( empty( $exclude_id ) || !in_array( $value, $exclude_id ) )
					$flat_post []= $value;
				continue;
			}

			if( filter_var( $value, FILTER_VALIDATE_URL ) !== false ){
				$value = url_to_postid($value);
				if( empty( $exclude_id ) || !in_array( $value, $exclude_id ) )
					$flat_post []= $value;
				continue;
			}

			$f_post = get_page_by_title($value, OBJECT, $post_types);
			if( !$f_post )
				continue;

			if( empty( $exclude_id ) || !in_array( $f_post->ID, $exclude_id ) )
				$flat_post []= $f_post->ID;

			wp_cache_delete( $f_post->ID, 'posts' );
			wp_cache_delete( $f_post->ID, 'post_meta' );
			clean_object_term_cache( $f_post->ID, $f_post->post_type );
			unset( $f_post );
		} unset( $value );

		if( empty( $flat_post ) )
			die( json_encode( array( 'method' => $method, 'data' => array( 'html' => $output ) ) ) );

		$flat_post = array_unique( $flat_post );

		foreach ( $flat_post as $value ) {
			$f_post = get_post($value);

			if( in_array( $f_post->post_type, $post_types ) )
				$output .= '<div class="item" data-id="' . strval($value) . '" data-type="' . $f_post->post_type . '">' . $f_post->post_title . '<span class="delete_me_pls"></span></div>';

			wp_cache_delete( $value, 'posts' );
			wp_cache_delete( $value, 'post_meta' );
			clean_object_term_cache( $value, $f_post->post_type );
			unset( $f_post );
		} unset( $value );

		die( json_encode( array( 'method' => $method, 'data' => array( 'html' => $output ) ) ) );
	}
}


if( !function_exists( 'flat_pm_settings_import' ) ){
	function flat_pm_settings_import( $method, $arr ){
		$data = json_decode( gzinflate( base64_decode( $arr['data'] ) ) );

		$data = json_decode( json_encode( $data ), true );

		if( !$data ){
			die( json_encode( array( 'method' => $method, 'data' => array( 'status' => 'error', 'message' => 'Ваши данные повреждены' ) ) ) );
		}




		$args_blocks = array(
			'posts_per_page' => -1,
			'post_type'      => 'flat_pm_block',
			'orderby'        => 'none',
			'post_status'    => 'publish',
			'fields'         => 'ids',
		);

		$flat_query = new WP_Query;
		$flat_blocks = $flat_query->query( $args_blocks );

		foreach( $flat_blocks as $block ){

			wp_delete_post( $block, true );

		} unset( $block );





		$args_folders = array(
			'taxonomy'   => 'flat_pm_block_folders',
			'hide_empty' => false,
			'orderby'    => 'none',
			'fields'     => 'ids',
		);

		$folders = get_terms( $args_folders );

		foreach( $folders as $folder ){

			wp_delete_term( $folder, 'flat_pm_block_folders', array( 'force_default' => true ) );

		} unset( $folder );




		$new_folders = $data['folders'];

		if( !empty( $new_folders ) ){
			foreach ( $new_folders as $folder ) {

				$folder = $folder;

				$term_id = wp_insert_term( $folder['folder_title'], 'flat_pm_block_folders' );

				if( !empty( $folder['folder_meta'] ) ){
					foreach ( $folder['folder_meta'] as $key => $value ) {

						if( $value != '' ){
							if( in_array( $key, array( 'flat_pm_folder_enabled' ) ) ){
								$ret = update_term_meta( (int)$term_id['term_id'], $key, (int)$value );
							}else{
								$ret = update_term_meta( (int)$term_id['term_id'], $key, $value );
							}
						}

					} unset( $key, $value );
				}

			} unset( $folder );
		}




		$new_blocks = $data['blocks'];

		if( isset( $new_blocks ) && is_array( $new_blocks ) ){
			foreach ( $new_blocks as $block ) {

				$args = array(
					'post_title'  => $block['block_title'],
					'post_status' => $block['block_status'],
					'post_type'   => 'flat_pm_block'
				);
				$new_post_id = wp_insert_post( $args );

				if( !empty( $block['block_meta'] ) ){
					foreach ( $block['block_meta'] as $key => $value ) {

						if( in_array( $key, array( 'flat_pm_order_ID', 'flat_pm_block_enabled' ) ) ){
							update_post_meta( (int)$new_post_id, $key, (int)$value );
						}else{
							update_post_meta( (int)$new_post_id, $key, $value );
						}

					} unset( $key, $value );
				}

				if( !empty( $block['folder_name'] ) ){

					$second_param = get_term_by( 'name', $block['folder_name'], 'flat_pm_block_folders' );

					wp_set_object_terms( $new_post_id, $second_param->term_id, 'flat_pm_block_folders', false );

				}

			} unset( $block );
		}




		flat_pm_clear_all_cache();

		die( json_encode( array( 'method' => $method, 'data' => array( 'status' => 'success', 'message' => 'Импорт завершён успешно!' ) ) ) );
	}
}


// !--sub_functions


add_action( 'wp_ajax_flat_pm_admin', 'ajax_hendler_flat_pm_admin' );
if( !function_exists( 'ajax_hendler_flat_pm_admin' ) ){
	function ajax_hendler_flat_pm_admin(){
		$arr    = isset( $_REQUEST['data_me']['arr'] )    ? flat_pm_recursive_esc_html( $_REQUEST['data_me']['arr'] ) : array();
		$method = isset( $_REQUEST['data_me']['method'] ) ? sanitize_text_field( $_REQUEST['data_me']['method'] ) : '';

		$data   = array( 'message' => 'Ошибочный метод', 'status' => 'danger' );

		$fpm_fn = 'flat_pm_' . $method;
		if( !empty( $method ) && function_exists( $fpm_fn ) )
			$fpm_fn( $method, $arr );
		else die( json_encode( array( 'method' => $method, 'data' => $data ) ) );
	}
}
?>