<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


if( !function_exists( 'block_geo_role_ip' ) ){
	function flat_pm_block_geo_role_ip( $method, $arr ){
		$client  = @$_SERVER['HTTP_CLIENT_IP'];
		$forward = @$_SERVER['HTTP_X_FORWARDED_FOR'];
		$remote  = @$_SERVER['REMOTE_ADDR'];

		if( filter_var( $client, FILTER_VALIDATE_IP ) ) $ip = $client;
		elseif( filter_var( $forward, FILTER_VALIDATE_IP ) ) $ip = $forward;
		else $ip = $remote;

		$data = array(
			'ip'      => 'true',
			'city'    => '',
			'country' => '',
			'ccode'   => '',
			'role'    => '',
		);




		$file = ABSPATH . '/ip.txt';

		if( !file_exists( $file ) ){
			file_put_contents( $file, '' );
		}

		$content = file_get_contents( $file, true );

		if( $content != false && $content != '' ){
			$ip_array = explode( PHP_EOL, $content );

			if( in_array( $ip, $ip_array ) ){
				$data['ip'] = 'false';
			}
		}




		$json = wp_remote_get( 'http://pro.ip-api.com/json/' . $ip . '?key=SduzT5O3D4IUq1z&lang=ru' );

		if ( !is_wp_error( $json ) ) {
			$query = json_decode( $json['body'] );
		}else{
			$query->city = '';
			$query->country = '';
			$query->countryCode = '';
		}

		if( $query && $query->status == 'success' ){
			$data['city']    = $query->city;
			$data['country'] = $query->country;
			$data['ccode']   = $query->countryCode;
		}





		if( is_user_logged_in() ){
			$user = wp_get_current_user();
			$roles = (array)$user->roles;
			$role = $roles[0];
		}else{
			$role = 'not_logged_in';
		}

		$data['role'] = $role;




		$data = array_map( 'mb_strtolower', $data );

		die( json_encode( array( 'method' => $method, 'data' => $data ) ) );
	}
}


// !--sub_functions


add_action( 'wp_ajax_flat_pm_ajax',        'ajax_hendler_flat_pm_ajax' );
add_action( 'wp_ajax_nopriv_flat_pm_ajax', 'ajax_hendler_flat_pm_ajax' );
if( !function_exists( 'ajax_hendler_flat_pm_ajax' ) ){
	function ajax_hendler_flat_pm_ajax(){
		$arr    = isset( $_REQUEST['data_me']['arr'] )    ? flat_pm_recursive_esc_html( $_REQUEST['data_me']['arr'] ) : array();
		$method = isset( $_REQUEST['data_me']['method'] ) ? sanitize_text_field( $_REQUEST['data_me']['method'] ) : '';

		$data   = array( 'message' => 'Ошибочный метод', 'status' => 'danger' );

		$fpm_fn = 'flat_pm_' . $method;
		if( !empty( $method ) && function_exists( $fpm_fn ) )
			$fpm_fn( $method, $arr );
		else die( json_encode( array( 'method' => $method, 'data' => $data ) ) );
	}
}
?>