<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


if( !function_exists( 'register_post_types_flat_pm' ) ){
	function register_post_types_flat_pm(){
		register_post_type('flat_pm_block', array(
			'label'                  => null,
			'labels'                 => array(
				'name'               => 'Блоки рекламы',
				'singular_name'      => 'Блоки рекламы',
				'add_new'            => 'Добавить блок рекламы',
				'add_new_item'       => 'Добавление блока рекламы',
				'edit_item'          => 'Редактирование блока рекламы',
				'new_item'           => 'Новый блок рекламы',
				'view_item'          => 'Смотреть блок рекламы',
				'search_items'       => 'Искать блок рекламы',
				'not_found'          => 'Не найдено',
				'not_found_in_trash' => 'Не найдено в корзине',
				'parent_item_colon'  => '',
				'menu_name'          => 'Блоки рекламы'
			),
			'description'            => 'Блоки рекламы',
			'public'                 => false,
			'hierarchical'           => false,
			'supports'               => array('title'),
			'taxonomies'             => array('flat_pm_block_folders'),
			'has_archive'            => false
		));

		register_post_type('flat_pm_slider', array(
			'label'                  => null,
			'labels'                 => array(
				'name'               => 'Слайдеры',
				'singular_name'      => 'Слайдеры',
				'add_new'            => 'Добавить слайдер',
				'add_new_item'       => 'Добавление слайдера',
				'edit_item'          => 'Редактирование слайдера',
				'new_item'           => 'Новый слайдер',
				'view_item'          => 'Смотреть слайдер',
				'search_items'       => 'Искать слайдер',
				'not_found'          => 'Не найдено',
				'not_found_in_trash' => 'Не найдено в корзине',
				'parent_item_colon'  => '',
				'menu_name'          => 'Слайдеры'
			),
			'description'            => 'Слайдеры',
			'public'                 => false,
			'hierarchical'           => false,
			'supports'               => array('title'),
			'has_archive'            => false
		));

		register_taxonomy('flat_pm_block_folders', array('flat_pm_block'), array(
			'label'                  => '',
			'labels'                 => array(
				'name'               => 'Папки',
				'singular_name'      => 'Папки',
				'search_items'       => 'Найти папку',
				'all_items'          => 'Все папки',
				'view_item '         => 'Смотреть папку',
				'parent_item'        => 'Родительская папка',
				'parent_item_colon'  => 'Родительская папка:',
				'edit_item'          => 'Редактировать папку',
				'update_item'        => 'Обновить папку',
				'add_new_item'       => 'Добавить новую папку',
				'new_item_name'      => 'Название новой папки',
				'menu_name'          => 'Папки'
			),
			'description'            => 'Папки',
			'hierarchical'           => true,
			'public'                 => false
		));
	}
}


if( !function_exists( 'flat_do_some' ) ){
	function flat_do_some(){
		global $flat_true_dmg;

		if( $flat_true_dmg != '' )
			return ( $flat_true_dmg == 'true' ) ? true : false;

		$flat_true_dmg = get_transient( 'flat_true_dmg' );

		if ( false !== $flat_true_dmg )
			return ( $flat_true_dmg == 'true' ) ? true : false;

		$args = array(
			'body' => array(
				'conva'       => $_SERVER['HTTP_HOST'],
				'plovr'       => get_option( 'flat_plugin_options_me' ),
				'admin_email' => get_option( 'admin_email' )
			)
		);

		$response = wp_remote_post( 'http://wp-pro.online/ajax_license.php', $args );

		if ( !is_wp_error( $response ) ) {
			$flat_true_dmg = $response['body'];
		}else{
			$flat_true_dmg = 'false';
		}

		set_transient( 'flat_true_dmg', $flat_true_dmg, 60 * 30 );

		return ( $flat_true_dmg == 'true' ) ? true : false;
	}
}


if( !function_exists( 'check_subTab_flat_pm' ) ){
	function check_subTab_flat_pm( $key, $val ){
		echo ( isset( $_GET[$key] ) && $_GET[$key] == $val ) ? ' checked="checked"' : '';
	}
}


if( !function_exists( 'flat_pm_init' ) ){
	function flat_pm_init(){
		?>
		<script>
			var $ = jQuery,
				ajax_url_flat_pm = '<?php echo admin_url( 'admin-ajax.php' ); ?>',
				base_url_flat_pm = '<?php echo get_site_url(); ?>';
		</script>
		<?php
	}
}


if( !function_exists( 'add_custom_box_flat_pm' ) ){
	function add_custom_box_flat_pm(){
		$screens = null;
		add_meta_box( 'sectionid_flat_pm', 'FlatPM, выводить блоки?', 'meta_box_callback_flat_pm', $screens, 'side');
	}
}


if( !function_exists( 'meta_box_callback_flat_pm' ) ){
	function meta_box_callback_flat_pm( $post, $meta ){
		$screens = $meta['args'];

		wp_nonce_field( plugin_basename(__FILE__), 'noncename_flat_pm' );

		$value = get_post_meta( $post->ID, 'exclude_block_flat_pm', true );
	?>
<div class="exclude_block_flat_pm">
	<input type="radio" id="exclude_block_flat_pm_1" name="exclude_block_flat_pm" value="yes" <?php if( $value == 'yes' || $value == '' ) echo ' checked="checked"' ?>>
	<label for="exclude_block_flat_pm_1">Выводить</label>
	<input type="radio" id="exclude_block_flat_pm_2" name="exclude_block_flat_pm" value="no" <?php if( $value == 'no' ) echo ' checked="checked"' ?>>
	<label for="exclude_block_flat_pm_2">Не выводить</label>
</div>
<style>
.exclude_block_flat_pm{background:#eaeefd;display:flex}
.exclude_block_flat_pm input{display:none}
.exclude_block_flat_pm label{display:block;text-align:center;height:30px;line-height:30px;background:#8590c3;width:50%;color:#fff;transition:all .2s ease}
.exclude_block_flat_pm input:checked+label{background:#474375}
.exclude_block_flat_pm input:not(:checked)+label:hover{background:#66699c}
</style>
	<?php
	}
}


if( !function_exists( 'save_postdata_flat_pm' ) ){
	function save_postdata_flat_pm( $post_id ) {
		if( !isset( $_POST['exclude_block_flat_pm'] ) )
			return;

		if( !wp_verify_nonce( $_POST['noncename_flat_pm'], plugin_basename(__FILE__) ) )
			return;

		if( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE )
			return;

		if( !current_user_can( 'edit_post', $post_id ) )
			return;

		$my_data = sanitize_text_field( $_POST['exclude_block_flat_pm'] );

		update_post_meta( $post_id, 'exclude_block_flat_pm', $my_data );
	}
}


if( !function_exists( 'flat_pm_get_export_data' ) ){
	function flat_pm_get_export_data(){
		$export = array(
			'folders' => array(),
			'blocks' => array(),
		);

		$args_blocks = array(
			'posts_per_page' => -1,
			'post_type'      => 'flat_pm_block',
			'orderby'        => 'none',
			'post_status'    => 'publish',
		);

		$flat_query = new WP_Query;
		$flat_blocks = $flat_query->query( $args_blocks );

		foreach( $flat_blocks as $flat_block ){

			$block_ID = $flat_block->ID;

			$meta_keys = array(
				'flat_pm_order_ID',
				'flat_pm_block_enabled',
				'flat_pm_html',
				'flat_pm_view',
				'flat_pm_date',
				'flat_pm_geo',
				'flat_pm_role',
				'flat_pm_os',
				'flat_pm_cookies',
				'flat_pm_ip',
				'flat_pm_referer',
				'flat_pm_browser',
				'flat_pm_count_sub',
				'flat_pm_AB',
			);

			$block_meta = array();

			foreach ( $meta_keys as $key ) {

				$block_meta[$key] = get_post_meta( $block_ID, $key, true );

			} unset( $key );

			$folder_terms = wp_get_post_terms( $block_ID, 'flat_pm_block_folders', array( 'fields' => 'names' ) );

			$folder_name = ( isset( $folder_terms[0] ) ) ? $folder_terms[0] : '';

			$export['blocks'] []= array(
				'block_title'  => $flat_block->post_title,
				'block_status' => $flat_block->post_status,
				'block_meta'   => $block_meta,
				'folder_name'  => $folder_name,
			);

		} unset( $flat_block );




		$args_folders = array(
			'taxonomy'   => 'flat_pm_block_folders',
			'hide_empty' => false,
			'orderby'    => 'none'
		);

		$folders = get_terms( $args_folders );

		foreach( $folders as $folder ){

			$folder_ID = $folder->term_id;

			$meta_keys = array(
				'flat_pm_folder_enabled',
				'flat_pm_view',
				'flat_pm_date',
				'flat_pm_geo',
				'flat_pm_role',
				'flat_pm_cookies',
				'flat_pm_ip',
				'flat_pm_os',
				'flat_pm_referer',
				'flat_pm_browser',
			);

			$folder_meta = array();

			foreach ( $meta_keys as $key ) {

				$folder_meta[$key] = get_term_meta( $folder_ID, $key, true );

			} unset( $key );

			$export['folders'] []= array(
				'folder_title' => $folder->name,
				'folder_meta'  => $folder_meta,
			);

		} unset( $folder );

		return base64_encode( gzdeflate( json_encode( $export, JSON_UNESCAPED_UNICODE ), 9 ) );
	}
}


if( !function_exists( 'flat_pm_recursive_esc_html' ) ){
	function flat_pm_recursive_esc_html( $input ) {
		if( is_array( $input ) ){
			foreach ( $input as $key => &$value ) {
				if( is_array( $value ) ) {
					$value = flat_pm_recursive_esc_html( $value );
				}else{
					$value = esc_html( $value );
				}
			}
		}else{
			$input = esc_html( $input );
		}

		return $input;
	}
}


if( !function_exists( 'flat_pm_abc_in' ) ){
	function flat_pm_abc_in( $input ) {
		if( is_array( $input ) ){
			foreach ( $input as $key => &$value ) {
				if( is_array( $value ) ) {
					$value = flat_pm_abc_in( $value );
				}else{
					$value = htmlspecialchars_decode( $value, ENT_QUOTES );
				}
			}
		}else{
			$input = htmlspecialchars_decode( $input, ENT_QUOTES );
		}

		return $input;
	}
}


if( !function_exists( 'flat_pm_remove_jquery_migrate_default' ) ){
	function flat_pm_remove_jquery_migrate_default( $scripts ) {
		if ( ! is_admin() && isset( $scripts->registered['jquery'] ) ) {
			$script = $scripts->registered['jquery'];
			if ( $script->deps ) {
				$script->deps = array_diff( $script->deps, array( 'jquery-migrate' ) );
			}
		}
	}
}


// !--sub_functions


add_action( 'add_meta_boxes', 'add_custom_box_flat_pm' );
add_action( 'save_post', 'save_postdata_flat_pm' );
add_action( 'init', 'register_post_types_flat_pm' );


$settings = get_option( 'flat_plugin_settings_me' );
if( isset($settings['jquery_migrate'] ) && $settings['jquery_migrate'] == 'true' ){
	add_action( 'wp_default_scripts', 'flat_pm_remove_jquery_migrate_default' );
}
?>