<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


if( !function_exists( 'flat_pm_array_merge' ) ){
	function flat_pm_array_merge( $arr ){
		$temp_arr = array();

		foreach ( $arr as $inner_arr ) {
			$temp_arr = array_merge( $temp_arr, $inner_arr );
		} unset( $inner_arr );

		return $temp_arr;
	}
}


if( !function_exists( 'flat_pm_pre_filter_content' ) ){
	function flat_pm_pre_filter_content( $content ){
		if( empty( $content ) )
			return;

		return '<div class="flat_pm_start"></div>' . PHP_EOL . $content . PHP_EOL . '<div class="flat_pm_end"></div>';
	}
}


if( !function_exists( 'flat_pm_filter_content' ) ){
	function flat_pm_filter_content( $content ){

		$exclude_block = 'yes';

		if( wp_doing_ajax() ){
			global $post;
			$we_are_hear            = 'is_single';
			$curr_post_id           = $post->ID;
			$curr_post_type         = $post->post_type;
			$curr_post_taxs         = get_object_taxonomies( $curr_post_type );
			$curr_post_terms        = array();
			$curr_post_terms_parent = array();

			if( is_array( $curr_post_taxs ) ){
				foreach ( $curr_post_taxs as $tax_value ) {
					$terms_arr = get_the_terms( $curr_post_id, $tax_value );
					if( is_array( $terms_arr ) ){
						foreach ( $terms_arr as $term_value) {
							$curr_post_terms []= $term_value->term_id;

							$term_parent = $term_value->parent;
							while( $term_parent != 0 ){
								$curr_post_terms_parent []= $term_parent;

								$term_parent = get_term( $term_parent )->parent;
							}
						} unset( $term_value );
					}
				} unset( $tax_value );
			}
		}else{
			if( is_admin() )
				return;

			wp_reset_query();
			wp_reset_postdata();

			switch ( true ) {
				case ( is_home() || is_front_page() ) :
					$we_are_hear     = 'is_home';
					break;

				case ( is_search() ) :
					$we_are_hear     = 'is_search';
					break;

				case ( is_post_type_archive() && is_archive() ) :
					$we_are_hear     = 'is_archive';
					$post_type_name  = get_queried_object()->name;
					break;

				case ( ( is_tax() || is_category() || is_tag() ) && is_archive() ) :
					$we_are_hear     = 'is_tax';
					$curr_term_id    = get_queried_object()->term_id;
					break;

				case ( is_single() || is_page() ) :
					$we_are_hear            = 'is_single';
					$curr_post_id           = get_queried_object()->ID;
					$curr_post_type         = get_queried_object()->post_type;
					$curr_post_taxs         = get_object_taxonomies( $curr_post_type );
					$curr_post_terms        = array();
					$curr_post_terms_parent = array();

					$exclude_block_flat_pm = get_post_meta( $curr_post_id, 'exclude_block_flat_pm', true );
					$exclude_block = ( $exclude_block_flat_pm == 'yes' || $exclude_block_flat_pm == '' ) ? 'yes' : 'no';

					if( is_array( $curr_post_taxs ) ){
						foreach ( $curr_post_taxs as $tax_value ) {
							$terms_arr = get_the_terms( $curr_post_id, $tax_value );
							if( is_array( $terms_arr ) ){
								foreach ( $terms_arr as $term_value) {
									$curr_post_terms []= $term_value->term_id;

									$term_parent = $term_value->parent;
									while( $term_parent != 0 ){
										$curr_post_terms_parent []= $term_parent;

										$term_parent = get_term( $term_parent )->parent;
									}
								} unset( $term_value );
							}
						} unset( $tax_value );
					}
					break;

				default:
					break;
			}
		}

		$global_output = array();
		$nameTypes     = array( 'referer', 'os', 'browser', 'role', 'cookies', 'utmget', 'ip' );
		$allNameTypes  = array( 'geo', 'referer', 'os', 'browser', 'date', 'role', 'cookies', 'utmget', 'ip' );
		$nameLimits    = array( 'chapter_limit', 'chapter_sub', 'title_limit', 'title_sub' );

		$args_flat_pm = array(
			'posts_per_page' => -1,
			'post_type'      => 'flat_pm_block',
			'order'          => 'ASC',
			'orderby'        => 'meta_value_num',
			'meta_key'       => 'flat_pm_order_ID',
			'post_status'    => 'publish',
		);

		$flat_query = new WP_Query;
		$flat_query_posts = $flat_query->query( $args_flat_pm );



		if( is_array( $flat_query_posts ) && $exclude_block == 'yes' ) :



		foreach( $flat_query_posts as $flat_query_post ){
			global $fpm_block_id;

			$blockID = $flat_query_post->ID;

			$fpm_block_id = $blockID;

			$block_view = get_post_meta( $blockID, 'flat_pm_view', true );

			if( $block_view['view_enabled'] != 'true' || wp_doing_ajax() &&
				!(
					( isset( $block_view['how']['onсe']['search_all'] )     && $block_view['how']['onсe']['search_all']     == 'false' ) ||
					( isset( $block_view['how']['iterable']['search_all'] ) && $block_view['how']['iterable']['search_all'] == 'false' ) ||
					( isset( $block_view['how']['simple'] ) )
				)
			) continue;



			/**
			 * ****************************************************************************
			 *   HTML rule ckeck
			 * *****************************************************************************
			 */

			$block_html   = get_post_meta( $blockID, 'flat_pm_html', true );

			$output       = $block_view;
			$output['ID'] = (string)$blockID;

			unset( $output['view_enabled'], $output['where'] );

			$temp_html = $block_html;

			foreach ( $temp_html as $key => $value ) {
				if( isset( $block_html[$key]['enabled'] ) && $block_html[$key]['enabled'] == '0' ){
					unset( $block_html[$key] );
					continue;
				}

				$block_html[$key]['fst'] = do_shortcode( htmlspecialchars_decode( $block_html[$key]['html_main'], ENT_QUOTES ) );
				$block_html[$key]['snd'] = do_shortcode( htmlspecialchars_decode( $block_html[$key]['html_block'], ENT_QUOTES ) );

				$block_html[$key]['res_of'] = $block_html[$key]['resolution_from'];
				$block_html[$key]['res_to'] = $block_html[$key]['resolution_to'];

				if( $block_html[$key]['group'] == '0' ) unset( $block_html[$key]['group'] );

				unset(
					$block_html[$key]['enabled'],
					$block_html[$key]['html_main'],
					$block_html[$key]['html_block'],
					$block_html[$key]['resolution_from'],
					$block_html[$key]['resolution_to'],
					$block_html[$key]['html_main_name'],
					$block_html[$key]['html_block_name']
				);
			} unset( $value, $key, $temp_html );

			if( !is_array( $block_html ) && !is_object( $block_html ) && count( $block_html ) == 0 )
				continue;

			sort( $block_html );

			$output['html'] = $block_html;



			/**
			 * ****************************************************************************
			 *   GET all meta post and folder
			 *   $allNameTypes
			 * *****************************************************************************
			 */

			foreach ( $allNameTypes as $type ) {
				${ "block_$type" } = get_post_meta( $blockID, 'flat_pm_'.$type , true );
			} unset( $type );

			$folderTerm        = get_the_terms( $blockID, 'flat_pm_block_folders' );
			if( $folderTerm && !is_wp_error( $folderTerm ) ){
				$folderTerm    = $folderTerm[0];
				$folderID      = $folderTerm->term_id;
				$folder_filter = get_term_meta( $folderID, 'flat_pm_folder_enabled', true ) == '1' ? true : false;
			}else{
				$folder_filter = false;
			}

			if( $folder_filter ){
				foreach ( $allNameTypes as $type ) {
					${ "folder_$type" } = get_term_meta( $folderID, 'flat_pm_'.$type , true );
				} unset( $type );

				$folder_view = get_term_meta( $folderID, 'flat_pm_view' , true );

				if( isset( $folder_view['where'] ) && is_array( $folder_view['where'] ) ){
					foreach ( $folder_view['where'] as $key => $value ) {
						$block_view['where'][$key] = $folder_view['where'][$key];
					} unset( $key, $value );
				}
			}



			/**
			 * ****************************************************************************
			 *   $nameLimits rule ckeck
			 * *****************************************************************************
			 */

			foreach ( $nameLimits as $limit ) {
				if( empty( $block_view[$limit] ) ) unset( $output[$limit] );
			} unset( $limit );



			/**
			 * ****************************************************************************
			 *   GEO rule ckeck
			 * *****************************************************************************
			 */

			if( $block_geo && $block_geo['geo_enabled'] == 'true' ){
				$output['geo'] = $block_geo;

				if( $output['geo']['city_enabled'][0] == '' )     unset( $output['geo']['city_enabled'] );
				if( $output['geo']['city_disabled'][0] == '' )    unset( $output['geo']['city_disabled'] );
				if( $output['geo']['country_enabled'][0] == '' )  unset( $output['geo']['country_enabled'] );
				if( $output['geo']['country_disabled'][0] == '' ) unset( $output['geo']['country_disabled'] );

				unset( $output['geo']['geo_enabled'] );
			}
			if( $folder_filter && $folder_geo['geo_enabled'] == 'true' ){
				isset( $folder_geo['city_enabled'] )     && '' != $folder_geo['city_enabled'][0]     && $output['geo']['city_enabled']     = $folder_geo['city_enabled'];
				isset( $folder_geo['city_disabled'] )    && '' != $folder_geo['city_disabled'][0]    && $output['geo']['city_disabled']    = $folder_geo['city_disabled'];
				isset( $folder_geo['country_enabled'] )  && '' != $folder_geo['country_enabled'][0]  && $output['geo']['country_enabled']  = $folder_geo['country_enabled'];
				isset( $folder_geo['country_disabled'] ) && '' != $folder_geo['country_disabled'][0] && $output['geo']['country_disabled'] = $folder_geo['country_disabled'];

				unset( $output['geo']['geo_enabled'] );
			}
			if( empty( $output['geo'] ) ) unset( $output['geo'] );



			/**
			 * ****************************************************************************
			 *   $nameTypes rule ckeck
			 * *****************************************************************************
			 */

			foreach ( $nameTypes as $type ) {
				if( ${ "block_$type" } && ${ "block_$type" }['enabled'] == 'true' ){
					$output[$type] = ${ "block_$type" };

					if( isset( $output[$type][$type.'_enabled'][0] )  && $output[$type][$type.'_enabled'][0] == '' )  unset( $output[$type][$type.'_enabled'] );
					if( isset( $output[$type][$type.'_disabled'][0] ) && $output[$type][$type.'_disabled'][0] == '' ) unset( $output[$type][$type.'_disabled'] );

					unset( $output[$type]['enabled'] );
				}
				if( $folder_filter && ${ "folder_$type" } && ${ "folder_$type" }['enabled'] == 'true' ){
					isset( ${ "folder_$type" }[$type.'_enabled'] ) &&
					${ "folder_$type" }[$type.'_enabled'][0] != '' &&
					$output[$type][$type.'_enabled'] = ${ "folder_$type" }[$type.'_enabled'];

					isset( ${ "folder_$type" }[$type.'_disabled'] ) &&
					${ "folder_$type" }[$type.'_disabled'][0] != '' &&
					$output[$type][$type.'_disabled'] = ${ "folder_$type" }[$type.'_disabled'];

					unset( $output[$type]['enabled'] );
				}
			} unset( $type );




			/**
			 * ****************************************************************************
			 *   role array keys && mb_strtolower
			 * *****************************************************************************
			 */

			if( isset( $output['role'] ) ){
				isset( $output['role']['role_enabled'] )  && $output['role']['role_enabled']  = array_map( 'mb_strtolower', array_keys( $output['role']['role_enabled'] ) );
				isset( $output['role']['role_disabled'] ) && $output['role']['role_disabled'] = array_map( 'mb_strtolower', array_keys( $output['role']['role_disabled'] ) );
			}




			/**
			 * ****************************************************************************
			 *   geo array mb_strtolower
			 * *****************************************************************************
			 */

			if( isset( $output['geo'] ) ){
				isset( $output['geo']['country_enabled'] )  && $output['geo']['country_enabled']  = array_map( 'mb_strtolower', $output['geo']['country_enabled'] );
				isset( $output['geo']['country_disabled'] ) && $output['geo']['country_disabled'] = array_map( 'mb_strtolower', $output['geo']['country_disabled'] );

				isset( $output['geo']['city_enabled'] )  && $output['geo']['city_enabled']  = array_map( 'mb_strtolower', $output['geo']['city_enabled'] );
				isset( $output['geo']['city_disabled'] ) && $output['geo']['city_disabled'] = array_map( 'mb_strtolower', $output['geo']['city_disabled'] );
			}




			/**
			 * ****************************************************************************
			 *   DATE rule ckeck
			 * *****************************************************************************
			 */

			if( $block_date['date_date_enabled'] == 'true' || $block_date['date_time_enabled'] == 'true' ){
				$output['date'] = $block_date;
				unset(
					$output['date']['date_enabled'],
					$output['date']['date_date_enabled'],
					$output['date']['date_time_enabled']
				);
			}
			if(
				( isset( $folder_date['date_date_enabled'] ) && $folder_date['date_date_enabled'] == 'true' ) || 
				( isset( $folder_date['date_time_enabled'] ) && $folder_date['date_time_enabled'] == 'true' )
			){
				$output['date'] = $folder_date;
				unset(
					$output['date']['date_enabled'],
					$output['date']['date_date_enabled'],
					$output['date']['date_time_enabled']
				);
			}


			if( ( isset( $folder_date['date_time_enabled'] ) && $folder_date['date_time_enabled'] == 'true' ) || $block_date['date_time_enabled'] == 'true' ){
				$explode_time_from = explode( ':', $output['date']['time_from'] );

				$output['date']['time_from'] = ( ( strlen( $explode_time_from[0] ) == 2 ) ? $explode_time_from[0] : '0' . $explode_time_from[0] ) . ':' . ( ( strlen( $explode_time_from[1] ) == 2 ) ? $explode_time_from[1] : '0' . $explode_time_from[1] );

				$explode_time_to = explode( ':', $output['date']['time_to'] );

				$output['date']['time_to'] = ( ( strlen( $explode_time_to[0] ) == 2 ) ? $explode_time_to[0] : '0' . $explode_time_to[0] ) . ':' . ( ( strlen( $explode_time_to[1] ) == 2 ) ? $explode_time_to[1] : '0' . $explode_time_to[1] );

				$output['date']['time_of'] = $output['date']['time_from'];
				unset( $output['date']['time_from'] );
			}else{
				unset( $output['date']['time_from'], $output['date']['time_to'] );
			}


			if( ( isset( $folder_date['date_date_enabled'] ) && $folder_date['date_date_enabled'] == 'true' ) || $block_date['date_date_enabled'] == 'true' ){
				$explode_date_from = explode( '.', $output['date']['date_from'] );

				$output['date']['date_from'] = $explode_date_from[2] . '-' . ( ( strlen( $explode_date_from[1] ) == 2 ) ? $explode_date_from[1] : '0' . $explode_date_from[1] ) . '-' . ( ( strlen( $explode_date_from[0] ) == 2 ) ? $explode_date_from[0] : '0' . $explode_date_from[0] );

				$explode_date_to = explode( '.', $output['date']['date_to'] );

				$output['date']['date_to'] = $explode_date_to[2] . '-' . ( ( strlen( $explode_date_to[1] ) == 2 ) ? $explode_date_to[1] : '0' . $explode_date_to[1] ) . '-' . ( ( strlen( $explode_date_to[0] ) == 2 ) ? $explode_date_to[0] : '0' . $explode_date_to[0] );

				$output['date']['date_of'] = $output['date']['date_from'];
				unset( $output['date']['date_from'] );
			}else{
				unset( $output['date']['date_from'], $output['date']['date_to'] );
			}



			/**
			 * ****************************************************************************
			 *   HOME, ARCHIVE, SEARCH rule ckeck
			 * *****************************************************************************
			 */

			if(
				(
					$we_are_hear == 'is_home' &&
					isset( $block_view['where']['show_in_home'] ) && $block_view['where']['show_in_home'] != '0'
				) ||
				(
					$we_are_hear == 'is_search' &&
					isset( $block_view['where']['show_in_search'] ) && $block_view['where']['show_in_search'] != '0'
				) ||
				(
					$we_are_hear == 'is_archive' &&
					isset( $block_view['where']['show_in_cat'] ) && $block_view['where']['show_in_cat'] != '0' &&
					in_array( $post_type_name, $block_view['where']['type_of_posts'] )
				)
			){
				$global_output []= $output;
			}



			/**
			 * ****************************************************************************
			 *   TAX rule ckeck
			 * *****************************************************************************
			 */

			if(
				$we_are_hear == 'is_tax' &&
				$block_view['where']['show_in_cat'] != '0'
			){
				$tax_enabled  = ( $isset_tax_enabled  = isset( $block_view['where']['tax_enabled'] ) )  ? $block_view['where']['tax_enabled']  : array();
				$tax_disabled = ( $isset_tax_disabled = isset( $block_view['where']['tax_disabled'] ) ) ? $block_view['where']['tax_disabled'] : array();

				$isset_tax_enabled  && $tax_enabled  = flat_pm_array_merge( $tax_enabled );
				$isset_tax_disabled && $tax_disabled = flat_pm_array_merge( $tax_disabled );

				if(
					( $isset_tax_enabled  &&  in_array( $curr_term_id, $tax_enabled  ) ) ||
					( $isset_tax_disabled && !in_array( $curr_term_id, $tax_disabled ) ) ||
					( !$isset_tax_enabled && !$isset_tax_disabled )
				) $global_output []= $output;
			}



			/**
			 * ****************************************************************************
			 *   SINGLE rule ckeck
			 * *****************************************************************************
			 */

			if(
				$we_are_hear == 'is_single' &&
				$block_view['where']['show_in_home'] != '2' &&
				$block_view['where']['show_in_cat'] != '2' &&
				in_array( $curr_post_type, $block_view['where']['type_of_posts'] )
			){
				$bool_out       = false;
				$tax_enabled    = ( $isset_tax_enabled    = isset( $block_view['where']['tax_enabled'] ) )    ? $block_view['where']['tax_enabled']    : array();
				$tax_disabled   = ( $isset_tax_disabled   = isset( $block_view['where']['tax_disabled'] ) )   ? $block_view['where']['tax_disabled']   : array();
				$posts_enabled  = ( $isset_posts_enabled  = isset( $block_view['where']['posts_enabled'] ) )  ? $block_view['where']['posts_enabled']  : array();
				$posts_disabled = ( $isset_posts_disabled = isset( $block_view['where']['posts_disabled'] ) ) ? $block_view['where']['posts_disabled'] : array();

				$isset_tax_enabled    && $tax_enabled    = flat_pm_array_merge( $tax_enabled );
				$isset_tax_disabled   && $tax_disabled   = flat_pm_array_merge( $tax_disabled );
				$isset_posts_enabled  && $posts_enabled  = flat_pm_array_merge( $posts_enabled );
				$isset_posts_disabled && $posts_disabled = flat_pm_array_merge( $posts_disabled );

				$isset_tax_enabled  && $tax_enabled_intersect_count  = count( array_intersect( array_merge( $curr_post_terms, $curr_post_terms_parent ), $tax_enabled ) );
				$isset_tax_disabled && $tax_disabled_intersect_count = count( array_intersect( $curr_post_terms, $tax_disabled ) );

				if(
					(  $isset_tax_disabled && !$isset_tax_enabled && 0 == $tax_disabled_intersect_count ) ||
					( !$isset_tax_disabled &&  $isset_tax_enabled && 0 != $tax_enabled_intersect_count ) ||
					(
						$isset_tax_disabled && $isset_tax_enabled &&
						0 != $tax_enabled_intersect_count && 0 == $tax_disabled_intersect_count
					)
				) $bool_out = true;

				if(
					!$bool_out && !$isset_tax_disabled && !$isset_tax_enabled &&
					(
						( !$isset_posts_enabled && !$isset_posts_disabled ) ||
						( $isset_posts_enabled  &&  in_array( $curr_post_id, $posts_enabled ) ) ||
						( $isset_posts_disabled && !in_array( $curr_post_id, $posts_disabled ) )
					)
				) $bool_out = true;
				elseif(
					$bool_out &&
					$isset_posts_disabled && in_array( $curr_post_id, $posts_disabled )
				) $bool_out = false;
				elseif(
					!$bool_out && $isset_posts_enabled && in_array( $curr_post_id, $posts_enabled )
				) $bool_out = true;

				$bool_out && $global_output []= $output;
			}
		} unset( $flat_query_posts, $args_flat_pm, $flat_query );



		endif; // end if is_array( $flat_query_posts )


		$type = 'flatpm_123';


		$settings = get_option( 'flat_plugin_settings_me' );


		if( ( isset( $settings['deferred'] ) && $settings['deferred'] == 'true' ) || ( isset( $settings['inseconds'] ) && $settings['inseconds'] == 'true' ) ){

			$events = 'touchstart mousemove';
			if( isset( $settings['deferred_events'] ) && $settings['deferred_events'] != '' ){
				$events = $settings['deferred_events'];
			}
			$events = implode( '.' . $type . ' ', explode( ' ', $events ) ) . '.' . $type . '';


			$timeout = '800';
			if( isset( $settings['inseconds_mseconds'] ) && $settings['inseconds_mseconds'] != '' ){
				$timeout = $settings['inseconds_mseconds'];
			}


			$deferred = '';
			if( isset( $settings['deferred'] ) && $settings['deferred'] == 'true' ){
				$deferred = '
				doc.bind(eventLoad, function() {
					doc.unbind(eventLoad);
					unbinded = true;
					clearTimeout( timer );
					flatPM_start();
				});';
			}


			$inseconds_deferred = '';
			if( isset( $settings['inseconds'] ) && $settings['inseconds'] == 'true' ){
				$inseconds_deferred = '
				$(window).on( "load", function(){
					if( unbinded ){
						return;
					}
					timer = setTimeout( function(){
						doc.unbind(eventLoad);
						flatPM_start();
					}, ' . $timeout . ' )
				} );';
			}


			$lighthouse = '';
			if( isset( $settings['lighthouse'] ) && $settings['lighthouse'] == 'true' ){
				$lighthouse = '
				if( navigator.userAgent.indexOf("Chrome-Lighthouse") > -1 ){
					return;
				}';
			}

			$output = '
			<script>flat_pm_arr = ' . json_encode( $global_output, JSON_UNESCAPED_UNICODE ) . ';</script>
			<script>
			function jQueryLoaded_' . $type . '( $ ) {
				if( "function" !== typeof flatPM_start ){
					return;
				}

				var doc = $(document),
					eventLoad = "' . $events . '",
					unbinded = false;

				' . $lighthouse . '

				var timer;
				' . $inseconds_deferred . '

				' . $deferred . '
			}

			function jQueryLoading_' . $type . '() {
				if (window.jQuery && typeof flat_pm_arr != "undefined") {
					jQueryLoaded_' . $type . '( jQuery )
				} else {
					setTimeout(function() {
						jQueryLoading_' . $type . '()
					}, 50)
				}
			}
			jQueryLoading_' . $type . '()
			</script>';

		}else{

			$output = '
			<script>flat_pm_arr = ' . json_encode( $global_output, JSON_UNESCAPED_UNICODE ) . ';</script>
			<script>
			function jQueryLoaded_' . $type . '( $ ) {
				if( "function" !== typeof flatPM_start ){
					return;
				}

				flatPM_start();
			}

			function jQueryLoading_' . $type . '() {
				if (window.jQuery && window.flat_pm_arr) {
					jQueryLoaded_' . $type . '( jQuery )
				} else {
					setTimeout(function() {
						jQueryLoading_' . $type . '()
					}, 50)
				}
			}
			jQueryLoading_' . $type . '()
			</script>';
		}


		if( wp_doing_ajax() )
			return $content . PHP_EOL . $output;

		echo $output;
		unset( $global_output );
	}
}


// !--sub_functions



if( wp_doing_ajax() ){

add_filter( 'the_content', 'flat_pm_filter_content', FLATPM_INT_MAX );

}

add_filter( 'the_content', 'flat_pm_pre_filter_content', 1 );
add_filter( 'wp_footer',   'flat_pm_filter_content', FLATPM_INT_MAX );
?>